make test: properly handle ctrl-c

Change-Id: Iab88886ebc1582626813777ea45ce97fc8e36443
Signed-off-by: Klement Sekera <ksekera@cisco.com>
This commit is contained in:
Klement Sekera
2017-08-11 10:06:15 +02:00
committed by Dave Wallace
parent 3214dc3823
commit db4e84cf2f
3 changed files with 36 additions and 3 deletions

View File

@ -17,9 +17,22 @@ atexit() {
exit $rv
}
trap "atexit" SIGINT SIGTERM
trap "atexit;" SIGINT SIGTERM
FORCE_FOREGROUND=$1
shift
source $1
shift
if [[ "${FORCE_FOREGROUND}" == "1" ]]
then
$*
else
$* &
wait
fi
$*
rv=$?
atexit
exit $rv

12
test/scripts/setsid_wrapper.sh Executable file
View File

@ -0,0 +1,12 @@
#!/bin/bash
if [[ "$1" == "1" ]]
then
setsid scripts/run_in_venv_with_cleanup.sh $*
pid=$!
else
setsid scripts/run_in_venv_with_cleanup.sh $* &
pid=$!
trap "echo setsid_wrapper.sh: got signal, killing child pid ${pid}; kill ${pid}; sleep .1;" SIGINT SIGTERM
wait
fi